//+------------------------------------------------------------------+
//|                                              RndTradeRndExit.mq4 |
//|                                            Copyright  2008 Grib |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008 Grib"
#property link      ""

extern int iMagic = 100;
extern int iStoploss = 20;
extern int iTakeProfit = 20;
extern string s1 = "Game A";
extern int iMaxTimeBetweenTrades = 1000;
extern string s2 = "Game B1";
extern int iTimeFrameB1 = 30;
extern int iMA_Period = 20;
extern string s3 = "Game B2";
extern int iTimeFrameB2 = 15;
extern int iRSI_Period = 7;
extern string s4 = "Money Management";
extern double dLots = 0.01;
extern bool UseMoneyMgmt = false;
extern double RiskPercent = 2;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   GlobalVariableSet("sRndChoice",-1);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
//OpenOrder(Symbol(),OP_SELL,dLots,iMagic,iStoploss,iTakeProfit);

 
 
 if(GlobalVariableGet("sRndChoice") == -1 && !SelectOrder(Symbol() ,iMagic,-1, -1, -1))
  {
    if(RndGen()>0.5)GlobalVariableSet("sRndChoice",0);
    else GlobalVariableSet("sRndChoice",1);
  }
 
 if(GlobalVariableGet("sRndChoice") == 0)SignalA(Symbol(), iMagic ,dLots ,iStoploss, iTakeProfit);
 
 if(GlobalVariableGet("sRndChoice") == 1)
  {
   SelectOrder(Symbol() ,iMagic,-1,"B1", -1,MODE_HISTORY);
   if(OrderProfit()>0)SignalB1(Symbol(), iMagic ,dLots, iStoploss,iTakeProfit,iTimeFrameB1 ,iMA_Period);
   else SignalB2(Symbol(), iMagic ,dLots, iStoploss, iTakeProfit, iTimeFrameB2, iRSI_Period);

  }
//Print(GlobalVariableGet("sRndChoice"));
}

void SignalB2(string sSymbol, int iMagic ,double dLots,int iStoploss,int iTakeProfit,int iTimeframe, int iRSI_Period)
{//rsi 7 tF 15
 double iRSI0 = iRSI( sSymbol, iTimeframe, iRSI_Period, PRICE_CLOSE, 0);
 double iRSI1 = iRSI( sSymbol, iTimeframe, iRSI_Period, PRICE_CLOSE, 1);
 if(iRSI1>70 && iRSI0<70)
 {
   OpenOrder(Symbol(),OP_SELL,dLots,iMagic,"B2",iStoploss,iTakeProfit);
   GlobalVariableSet("sRndChoice",-1);
 }
 if(iRSI1<30 && iRSI0>30)
 {
   OpenOrder(Symbol(),OP_BUY,dLots,iMagic,"B2",iStoploss,iTakeProfit);
   GlobalVariableSet("sRndChoice",-1);
 }
    Comment( "Game B2"+"\n"+
            "Retracement");

}
void SignalB1(string sSymbol, int iMagic ,double dLots,int iStoploss,int iTakeProfit,int iTimeframe,int iMA_Period)
{
   if (MarketInfo(sSymbol,MODE_BID)<iMA(Symbol(),iTimeframe,iMA_Period,0,MODE_EMA,PRICE_CLOSE,0))
   {
      OpenOrder(Symbol(),OP_SELL,dLots,iMagic,"B1",iStoploss,iTakeProfit);
      GlobalVariableSet("sRndChoice",-1);
   }
   if (MarketInfo(sSymbol,MODE_BID)>iMA(Symbol(),iTimeframe,iMA_Period,0,MODE_EMA,PRICE_CLOSE,0))
   {
      OpenOrder(Symbol(),OP_BUY,dLots,iMagic,"B1",iStoploss,iTakeProfit);
      GlobalVariableSet("sRndChoice",-1);
   }
    Comment( "Game B1"+"\n"+
            "Trending");
}

void SignalA(string sSymbol, int iMagic, double dLots,int iStoploss,int iTakeProfit)
{

static int iBuyNextTradeTime = 0;
static int iSellNextTradeTime = 0;

MathSrand(TimeLocal());

//For first time run, set new random start times
if(iSellNextTradeTime == 0) iSellNextTradeTime = TimeLocal() + RndGen() * iMaxTimeBetweenTrades;
if(iBuyNextTradeTime == 0) iBuyNextTradeTime = TimeLocal() + RndGen() * iMaxTimeBetweenTrades;
//end first time run

   if(!SelectOrder(sSymbol ,iMagic,OP_SELL, -1, -1) && iSellNextTradeTime < TimeLocal() && !SelectOrder(Symbol() ,iMagic,-1, -1, -1) )
   {
      OpenOrder(Symbol(),OP_SELL,dLots,iMagic,"A",iStoploss,iTakeProfit);
      iSellNextTradeTime = 0;
      GlobalVariableSet("sRndChoice",-1);
   }

   if(!SelectOrder(Symbol() ,iMagic,OP_BUY, -1, -1) && iBuyNextTradeTime < TimeLocal()  && !SelectOrder(Symbol() ,iMagic,-1, -1, -1) )
   {
      OpenOrder(Symbol(),OP_BUY,dLots,iMagic,"A",iStoploss,iTakeProfit);
      iBuyNextTradeTime = 0;
      GlobalVariableSet("sRndChoice",-1);
   }

//---------Comments----------
 string sNextBuyTime = CheckStringTime(TimeToStr(iBuyNextTradeTime-TimeLocal(),TIME_MINUTES|TIME_SECONDS));
 string sNextSellTime = CheckStringTime(TimeToStr(iSellNextTradeTime-TimeLocal(),TIME_MINUTES|TIME_SECONDS ));
 string sNextTradeTime = "";
 if((iBuyNextTradeTime-TimeLocal()) > (iSellNextTradeTime-TimeLocal()))
 sNextTradeTime = sNextSellTime;
 else sNextTradeTime = sNextBuyTime;

  Comment( "Game A"+"\n"+
           "Random"+"\n"+
           "Next Trade Time: "+sNextTradeTime+"\n"+
           "");           
//---------Comments End ------- 
}

//Random Generator
double RndGen()
{
double dRand = MathRand();
double dSymbolNum = StrToDouble(MagicGS(StringSubstr(Symbol(), 0, 3))+""+MagicGS(StringSubstr(Symbol(), 3, 3)));
return(StrToDouble(StringSubstr(DoubleToStr(dRand+dSymbolNum,0), StringLen(DoubleToStr(dRand+dSymbolNum,0))-2 )) / 99);
}

int MagicGS(string s)
{
if(s == "EUR")return(1);
if(s == "USD")return(2);
if(s == "GBP")return(3);
if(s == "JPY")return(4);
if(s == "CHF")return(5);
return(0);
}

string CheckStringTime(string sTime)
{
if(sTime == "invalid time")return("-");
else return(sTime);
}

//================ Open Orders =========================================================================================  
//

void OpenOrder(string sSymbol,int iType, double dLots,int iMagic,string sComment,double dStoploss,double dTakeProfit)
{ 
 dLots = GetLots(Symbol(), dLots, UseMoneyMgmt, RiskPercent, true);
 
 if(iType == OP_BUY)
  {
    if(dStoploss>0) dStoploss = MarketInfo(sSymbol,MODE_ASK)-dStoploss*MarketInfo(sSymbol,MODE_POINT);
   if(dTakeProfit>0)  dTakeProfit = MarketInfo(sSymbol,MODE_ASK)+dTakeProfit*MarketInfo(sSymbol,MODE_POINT);
  }
  if(iType == OP_SELL)
 {
   if(dStoploss>0)   dStoploss = MarketInfo(sSymbol,MODE_BID)+dStoploss*MarketInfo(sSymbol,MODE_POINT);
   if(dTakeProfit>0) dTakeProfit = MarketInfo(sSymbol,MODE_BID)-dTakeProfit*MarketInfo(sSymbol,MODE_POINT);
 }
 RefreshRates();
      if(iType == OP_BUY) OrderSend(sSymbol,OP_BUY,dLots,Ask,3,dStoploss,dTakeProfit,sComment,iMagic,0,Blue);
      if(iType == OP_SELL) OrderSend(sSymbol,OP_SELL,dLots,Bid,3,dStoploss,dTakeProfit,sComment,iMagic,0,Blue);
}
//

//=============== Close Orders =========================================================================
//

void CloseOrder(int iMagic, int iType)
{
   RefreshRates();
   if(SelectOrder(Symbol() ,iMagic,iType, -1, -1))
   OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),3,Blue); 
}
//

//=============== Select Orders =========================================================================
//
bool SelectOrder(string sOrderSymbol ,int iMagic, int iType, string sOrderComment, int iOrderTicket, int iPool = MODE_TRADES)
{
   sOrderSymbol = MiniCheck(sOrderSymbol);
   int cnt,total;
    if(iPool == MODE_TRADES)total = OrdersTotal();
    else total = OrdersHistoryTotal();
    
     for(cnt=total-1;cnt>=0;cnt--)
      {
        OrderSelect(cnt, SELECT_BY_POS, iPool);
        if ((OrderSymbol() == sOrderSymbol || sOrderSymbol == "-1") && (OrderMagicNumber()==iMagic || iMagic == -1)  && (OrderType()==iType || iType == -1) && (OrderComment() == sOrderComment || sOrderComment =="-1")  && (OrderTicket() == iOrderTicket || iOrderTicket == -1))
        return(true);
      }
     return(false);
} 

double GetLots(string sSymbol, double Lots, bool UseMoneyMgmt, double RiskPercent, bool BrokerPermitsFractionalLots)
{
// variables used for money management
double         MM_MinLotSize=0;
double         MM_MaxLotSize=0;
double         MM_LotStep=0;
double         MM_Decimals=0;
int            MM_AcctLeverage=0;
int            MM_CurrencyLotSize=0;
 
 sSymbol = MiniCheck(sSymbol);
 double OrderLotSize;
 
//----- Money Management & Lot Sizing Stuff.

  MM_AcctLeverage = AccountLeverage();
  MM_MinLotSize = MarketInfo(sSymbol,MODE_MINLOT);
  MM_MaxLotSize = MarketInfo(sSymbol,MODE_MAXLOT);
  MM_LotStep = MarketInfo(sSymbol,MODE_LOTSTEP);
  MM_CurrencyLotSize = MarketInfo(sSymbol,MODE_LOTSIZE);

  if(MM_LotStep == 0.01) {MM_Decimals = 2;}
  if(MM_LotStep == 0.1) {MM_Decimals = 1;}

  if (UseMoneyMgmt == true)
   {
    OrderLotSize = AccountEquity() * (RiskPercent * 0.01) / (MM_CurrencyLotSize / MM_AcctLeverage);
    if(BrokerPermitsFractionalLots == true)
      OrderLotSize = StrToDouble(DoubleToStr(OrderLotSize,MM_Decimals));
    else
      OrderLotSize = MathRound(OrderLotSize);
   }
   else
   {
    OrderLotSize = Lots;
   }

  if (OrderLotSize < MM_MinLotSize) {OrderLotSize = MM_MinLotSize;}
  if (OrderLotSize > MM_MaxLotSize) {OrderLotSize = MM_MaxLotSize;}

  return(OrderLotSize);
  
}

//Check if it is an mini acc or not and adjust symbol if needed
string MiniCheck(string sSymbol)
{
  if(StringFind(sSymbol, "m", 0) >= 0 && (StringFind(Symbol(), "m", 0) >= 0) )return(sSymbol);
  if(StringFind(sSymbol, "m", 0) >= 0 && !(StringFind(Symbol(), "m", 0) >= 0) )return(StringSubstr(sSymbol, 0, 6));
  if( !(StringFind(sSymbol, "m", 0) >= 0) && (StringFind(Symbol(), "m", 0) >= 0) )return(sSymbol+"m");
  return (sSymbol);
}